明经CAD社区

 找回密码
 注册

扫一扫,访问微社区

QQ登录

只需一步,快速开始

查看: 1340|回复: 4

[源码] [源码]批量绘制直线中垂线

[复制链接]
发表于 2013-9-8 20:40 | 显示全部楼层 |阅读模式
;;;***********绘制直线的中垂线 程序开始************
(defun c:zcx ()
  (setvar "pickadd" 1)
  (setvar "osmode" 15359)
  (setvar "cmdecho" 0)
  (command "undo" "be")
  (princ "\n★功能:批量绘制直线的中垂线.")
  (princ "\n本人邮箱:wudingyun2008@163.com")
  (setq ss (ssget '((0 . "LINE"))))
  (if (null ss)
    (progn (princ "\n★提示:未选取直线!") (exit))
  )
  (setq n (sslength ss))
  (setq i 0)
  (setvar "osmode" 0)
  (while (< i n)
    (setq entname (ssname ss i))
    (setq entdata (entget entname))
    (setq i (+ i 1))
    (setq ptqd (cdr (assoc 10 entdata)))
    (setq ptzd (cdr (assoc 11 entdata)))
    (setq dist (distance ptqd ptzd))
    (setq ang (angle ptqd ptzd))
    (setq ptqdx (car ptqd))
    (setq ptqdy (cadr ptqd))
    (setq ptzdx (car ptzd))
    (setq ptzdy (cadr ptzd))
    (setq ptzxx (/ (+ ptqdx ptzdx) 2))
    (setq ptzxy (/ (+ ptqdy ptzdy) 2))
    (setq
      pt1 (polar (list ptzxx ptzxy) (+ ang (angtof "90")) (/ dist 2))
    )
    (setq
      pt2 (polar (list ptzxx ptzxy) (+ ang (angtof "-90")) (/ dist 2))
    )
    (command "LAYER" "M" "中垂线" "C" "RED" "中垂线" "")
    (command "COLOR" "Bylayer")
    (command "LINE" pt1 pt2 "")
  )
  (command "undo" "e")
  (setvar "osmode" 15359)
  (princ)
)
;;;**************绘制直线的中垂线 程序结束**************
发表于 2014-8-20 19:28 | 显示全部楼层
谢谢分享。
发表于 2014-8-20 19:30 | 显示全部楼层
本帖最后由 lucas_3333 于 2014-8-20 19:48 编辑

只支持直线
http://bbs.mjtd.com/thread-95149-1-1.html
发表于 2018-1-14 03:40 | 显示全部楼层
如果多些选择就更好了
发表于 2018-1-14 08:49 | 显示全部楼层
谢谢! 荒野孤行 分向程序!!!
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号  
©2000-2017 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2018-10-15 16:34 , Processed in 0.406326 second(s), 27 queries , Gzip On.

Powered by Discuz! X3.3

© 2001-2013 Comsenz Inc.

快速回复 返回顶部 返回列表